Index: invariantview/docs/sphinx/_build/html/_sources/api/help_panel.txt
===================================================================
--- invariantview/docs/sphinx/_build/html/_sources/api/help_panel.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
+++ invariantview/docs/sphinx/_build/html/_sources/api/help_panel.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+help_panel
+******************************************************************************
+
+:mod:`sans.perspectives.invariant.help_panel`
+==============================================================================
+
+.. automodule:: sans.perspectives.invariant.help_panel
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: invariantview/docs/sphinx/_build/html/_sources/api/index.txt
===================================================================
--- invariantview/docs/sphinx/_build/html/_sources/api/index.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
+++ invariantview/docs/sphinx/_build/html/_sources/api/index.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
@@ -0,0 +1,20 @@
+.. Autogenerated by genmods.py
+
+.. _api-index:
+
+##############################################################################
+   Reference
+##############################################################################
+
+.. only:: html
+
+   :Release: |version|
+   :Date: |today|
+
+.. toctree::
+
+   help_panel.rst
+   invariant_details.rst
+   invariant_panel.rst
+   invariant_widgets.rst
+   invariant.rst
Index: invariantview/docs/sphinx/_build/html/_sources/api/invariant.txt
===================================================================
--- invariantview/docs/sphinx/_build/html/_sources/api/invariant.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
+++ invariantview/docs/sphinx/_build/html/_sources/api/invariant.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+invariant
+******************************************************************************
+
+:mod:`sans.perspectives.invariant.invariant`
+==============================================================================
+
+.. automodule:: sans.perspectives.invariant.invariant
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: invariantview/docs/sphinx/_build/html/_sources/api/invariant_details.txt
===================================================================
--- invariantview/docs/sphinx/_build/html/_sources/api/invariant_details.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
+++ invariantview/docs/sphinx/_build/html/_sources/api/invariant_details.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+invariant_details
+******************************************************************************
+
+:mod:`sans.perspectives.invariant.invariant_details`
+==============================================================================
+
+.. automodule:: sans.perspectives.invariant.invariant_details
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: invariantview/docs/sphinx/_build/html/_sources/api/invariant_panel.txt
===================================================================
--- invariantview/docs/sphinx/_build/html/_sources/api/invariant_panel.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
+++ invariantview/docs/sphinx/_build/html/_sources/api/invariant_panel.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+invariant_panel
+******************************************************************************
+
+:mod:`sans.perspectives.invariant.invariant_panel`
+==============================================================================
+
+.. automodule:: sans.perspectives.invariant.invariant_panel
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: invariantview/docs/sphinx/_build/html/_sources/api/invariant_widgets.txt
===================================================================
--- invariantview/docs/sphinx/_build/html/_sources/api/invariant_widgets.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
+++ invariantview/docs/sphinx/_build/html/_sources/api/invariant_widgets.txt	(revision 6126c25e2765bb584db34248d3fde4946f3fba79)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+invariant_widgets
+******************************************************************************
+
+:mod:`sans.perspectives.invariant.invariant_widgets`
+==============================================================================
+
+.. automodule:: sans.perspectives.invariant.invariant_widgets
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+