Index: src/sas/perspectives/calculator/media/data_operator_help.rst
===================================================================
--- src/sas/perspectives/calculator/media/data_operator_help.rst	(revision 98b30b46ac241d857a5698740991daae2c25c3c2)
+++ src/sas/perspectives/calculator/media/data_operator_help.rst	(revision 98b30b46ac241d857a5698740991daae2c25c3c2)
@@ -0,0 +1,39 @@
+.. data_operator_help.rst
+
+.. This is a port of the original SasView html help file to ReSTructured text
+.. by S King, ISIS, during SasView CodeCamp-III in Feb 2015.
+
+Data Operations Tool
+====================
+
+Description
+-----------
+This dialog panel provides arithmetic operations between two data sets (the 
+last data set could be a number).
+
+When data1 and data2 are selected, their x (or qx and qy for 2D) value(s)
+must match with each other.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+How To
+------
+1. Type the data name resulted from an operation.
+
+2) Select a data/theory in the drop down menus. When data2 is set to number, 
+   type a number in the text control box.
+
+3) Select an arithmetic operator symbol; + (for addition), - (for subtraction), 
+   * (for multiplication), / (for division), and | (for combination of two data
+   sets).
+
+   If two data sets do not match, the operation will fail and the background color
+   of the combo box items will turn to red (WIN only).
+
+4) If the operation is successful, hit the Apply button to make the new data.
+   Then the data name will be shown up in the data box in the data explorer.
+
+Note: Any errors and warnings will be displayed at the bottom of the SasView
+window.
+
+.. image:: data_oper_pic.png
Index: src/sas/perspectives/fitting/media/fitting_help.rst
===================================================================
--- src/sas/perspectives/fitting/media/fitting_help.rst	(revision ec392464eef959a5c2e87e6a72ed72fd7e947a07)
+++ src/sas/perspectives/fitting/media/fitting_help.rst	(revision 98b30b46ac241d857a5698740991daae2c25c3c2)
@@ -10,4 +10,16 @@
 .. |phi| unicode:: U+03C6
 .. |theta| unicode:: U+03B8
+.. |chi| unicode:: U+03C7
+
+.. |inlineimage004| image:: sm_image004.gif
+.. |inlineimage005| image:: sm_image005.gif
+.. |inlineimage008| image:: sm_image008.gif
+.. |inlineimage009| image:: sm_image009.gif
+.. |inlineimage010| image:: sm_image010.gif
+.. |inlineimage011| image:: sm_image011.gif
+.. |inlineimage012| image:: sm_image012.gif
+.. |inlineimage018| image:: sm_image018.gif
+.. |inlineimage019| image:: sm_image019.gif
+
 
 Fitting Perspective
@@ -61,5 +73,5 @@
 One of two fit-engines can be chosen from the Fitting menu bar. The Simple Fit-
 engine uses Scipy's leasqr and the Complex Fit-Engine is a custom optimizer 
-that provides a better chance to find the global minimum of the chi2 but that 
+that provides a better chance to find the global minimum of the |chi| 2 but that
 requires longer computation time. In order to set a data to a control panel 
 (FitPage), see the "DataLoader Help". Once a data set to the FiPage, select a 
@@ -532,5 +544,5 @@
 
 We use only these array values in the computation, therefore the mean value 
-given in the control panel, for example âradius = 60â, will be ignored.
+given in the control panel, for example Ã¢â¬Ëradius = 60Ã¢â¬â¢, will be ignored.
 
 .. _Gaussian_Distribution:
@@ -560,5 +572,5 @@
 normalization factor which will be determined during the numerical calculation. 
 The median value is the value given in the size parameter in the control panel, 
-for example, âradius = 60â.
+for example, Ã¢â¬Åradius = 60Ã¢â¬ï¿œ.
 
 The PD (polydispersity) is given by /sigma/
@@ -588,5 +600,5 @@
 which is determined during the numerical calculation.
 
-The z = 1/p2â 1.
+The z = 1/p2Ã¢â¬â 1.
 
 The PD (polydispersity) is
@@ -628,5 +640,5 @@
 Equation 1
 
-The functions .. image:: sm_image004.gif and .. image:: sm_image005.gif
+The functions |inlineimage004| and |inlineimage005|
 refer to the slit width weighting function and the slit height weighting 
 determined at the q point, respectively. Here, we assumes that the weighting 
@@ -643,8 +655,7 @@
 Equation 3
 
-so that .. image:: sm_image008.gif .. image:: sm_image009.gif for
-.. image:: sm_image010.gif and u.
-
-The .. image:: sm_image011.gif and .. image:: sm_image012.gif stand for
+so that |inlineimage008| |inlineimage009| for |inlineimage010| and u.
+
+The |inlineimage011| and |inlineimage012| stand for
 the slit height (FWHM/2) and the slit width (FWHM/2) in the q space. Now the 
 integral of Equation 1 is simplified to
@@ -660,11 +671,10 @@
 ------
 
-For .. image:: sm_image012.gif = 0 and .. image:: sm_image011.gif = 
-constant.
+For |inlineimage012| = 0 and |inlineimage011| = constant.
 
 .. image:: sm_image016.gif
 
 For discrete q values, at the q values from the data points and at the q 
-values extended up to qN= qi + .. image:: sm_image011.gif the smeared 
+values extended up to qN= qi + |inlineimage011| the smeared 
 intensity can be calculated approximately
 
@@ -673,17 +683,14 @@
 Equation 5
 
-.. image:: sm_image018.gif = 0 for *Is* in *j* < *i* or *j* > N-1*.
+|inlineimage018| = 0 for *Is* in *j* < *i* or *j* > N-1*.
 
 Case 2
 ------
 
-For .. image:: sm_image012.gif = constant and 
-.. image:: sm_image011.gif = 0.
+For |inlineimage012| = constant and |inlineimage011| = 0.
 
 Similarly to Case 1, we get
 
-.. image:: sm_image019.gif for qp= qi- .. image:: sm_image012.gif
-
-and qN= qi+ .. image:: sm_image012.gif. .. image:: sm_image018.gif = 0
+|inlineimage019| for qp= qi- |inlineimage012| and qN= qi+ |inlineimage012|. |inlineimage018| = 0
 for *Is* in *j* < *p* or *j* > *N-1*.
 
@@ -691,6 +698,6 @@
 ------
 
-For .. image:: sm_image011.gif = constant and 
-.. image:: sm_image011.gif = constant.
+For |inlineimage011| = constant and 
+|inlineimage011| = constant.
 
 In this case, the best way is to perform the integration, Equation 1, 
@@ -707,6 +714,6 @@
 Equation 7
 
-for qp= qi- .. image:: sm_image012.gif and
-qN= qi+ .. image:: sm_image012.gif. .. image:: sm_image018.gif = 0 for
+for qp= qi- |inlineimage012| and
+qN= qi+ |inlineimage012|. |inlineimage018| = 0 for
 *Is* in *j* < *p* or *j* > *N-1*.
 
@@ -745,5 +752,5 @@
 In Equation 9, x0 = qcos/theta/ and y0 = qsin/theta/, and the primed axes 
 are in the coordinate rotated by an angle /theta/ around the z-axis (below) 
-so that xâ0= x0cos/theta/+y0sin/theta/ and yâ0= -x0sin/theta/+y0cos/theta/.
+so that xÃ¢â¬â¢0= x0cos/theta/+y0sin/theta/ and yÃ¢â¬â¢0= -x0sin/theta/+y0cos/theta/.
 
 Note that the rotation angle is zero for x-y symmetric elliptical Gaussian 
@@ -754,5 +761,5 @@
 Now we consider a numerical integration where each bins in /theta/ and R are 
 *evenly* (this is to simplify the equation below) distributed by /delta//theta/ 
-and /delta/R, respectively, and it is assumed that I(xâ, yâ) is constant 
+and /delta/R, respectively, and it is assumed that I(xÃ¢â¬â¢, yÃ¢â¬â¢) is constant 
 within the bins which in turn becomes
 
@@ -762,5 +769,5 @@
 
 Since we have found the weighting factor on each bin points, it is convenient 
-to transform xâ-yâ back to x-y coordinate (rotating it by -/theta/ around z 
+to transform xÃ¢â¬â¢-yÃ¢â¬â¢ back to x-y coordinate (rotating it by -/theta/ around z 
 axis). Then, for the polar symmetric smear
 
@@ -940,5 +947,5 @@
 If this operation is successful, the new ftol value will be displayed in the 
 info line at the bottom of the SV window.Note that increasing the ftol value 
-may cause for the fitting to terminate with higher chisq.
+may cause for the fitting to terminate with higher |chi| sq.
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ